<?php
namespace Zeedhi\DevOps\Model\Projectmanagement\Repositories;

use Doctrine\ORM\EntityRepository;

class Commitment extends EntityRepository {







    public function getCommitmentsByCalendar($calendar,$organization ){

        $sql= "SELECT ID,
                    COMMITMENT_TYPE,
                    NAME AS NAME_EXCEPTION,
                    TO_CHAR(BEGIN_DATE,'DD/MM/YYYY') as BEGIN_DATE,
                    TO_CHAR(END_DATE,'DD/MM/YYYY') as END_DATE,
                    UNIT,
                    TIME_BREAK,
                    TO_CHAR(BEGIN_TIME_BREAK,'DD/MM/YYYY') as BEGIN_TIME_BREAK,
                    TO_CHAR(END_TIME_BREAK,'DD/MM/YYYY') as END_TIME_BREAK,
                    STATUS
                      FROM COMMITMENT
                     where ORGANIZATION = $organization
                       and  STATUS = 'A'
                       and CALENDAR = $calendar";
        return $this->getEntityManager()->getConnection()->fetchAll($sql);
    }
    public function getDataSetForEditExceptionByCalendarEntity($calendar){

        $sql = <<<SQL
			SELECT CO.ID,CO.CALENDAR,CO.NAME,CO.STATUS,CO.COMMITMENT_TYPE AS TYPE,CO.COMMITMENT_TYPE AS TYPE_NAME,
                    TO_CHAR(CO.BEGIN_DATE,'DD/MM/YYYY HH24:MI') as BEGIN_DATE_LIST,
                    TO_CHAR(CO.END_DATE,'DD/MM/YYYY HH24:MI') as END_DATE_LIST,
                    TO_CHAR(CO.BEGIN_DATE,'YYYY-MM-DD HH24:MI') as BEGIN_DATE,
                    TO_CHAR(CO.END_DATE,'YYYY-MM-DD HH24:MI') as END_DATE,
                    TO_CHAR(CO.BEGIN_TIME_BREAK,'YYYY-MM-DD') as BEGIN_DATE_BREAK,
                    TO_CHAR(CO.END_TIME_BREAK,'YYYY-MM-DD') as END_DATE_BREAK,
                    CO.UNIT,CO.TIME_BREAK
                 FROM CALENDAR C
                 JOIN COMMITMENT CO ON(CO.CALENDAR = C.ID)
                WHERE C.ID =  :calendar
SQL;
        $param = array(
            'calendar' => $calendar
        );
        return $this->getEntityManager()->getConnection()->fetchAll($sql,$param);
    }
    public function getDataSetForEditProjectException($project,$organization){

        $sql = <<<SQL
			SELECT CO.ID,CO.CALENDAR,CO.NAME,CO.STATUS,CO.COMMITMENT_TYPE AS TYPE,--CT.LABEL AS TYPE_NAME,
                    TO_CHAR(CO.BEGIN_DATE,'DD/MM/YYYY HH24:MI') as BEGIN_DATE_LIST,
                    TO_CHAR(CO.END_DATE,'DD/MM/YYYY HH24:MI') as END_DATE_LIST,
                    TO_CHAR(CO.BEGIN_DATE,'YYYY-MM-DD HH24:MI') as BEGIN_DATE,
                    TO_CHAR(CO.END_DATE,'YYYY-MM-DD HH24:MI') as END_DATE,
                    TO_CHAR(CO.BEGIN_TIME_BREAK,'YYYY-MM-DD') as BEGIN_DATE_BREAK,
                    TO_CHAR(CO.END_TIME_BREAK,'YYYY-MM-DD') as END_DATE_BREAK,
                    CO.UNIT,CO.TIME_BREAK
                 FROM PROJECT PRO
                 JOIN CALENDAR C ON (PRO.CALENDAR = C.ID)
                 INNER JOIN COMMITMENT CO ON(CO.CALENDAR = C.ID AND CO.ORGANIZATION = :organization)
                WHERE PRO.ID = :project
                  AND C.ORGANIZATION = :organization
SQL;
        $param = array(
            'project' => $project,
            'organization' => $organization
        );

        return $this->getEntityManager()->getConnection()->fetchAll($sql, $param);
    }


}